<?php

// test configuration
print("<strong>".$lang["Testing Configuration"]."</strong><br />\n");
test($lang["TestSql"], $dblink = @mysql_connect($config["mysql_host"], $config["mysql_user"], $config["mysql_password"]));
test($lang["Looking for database..."], @mysql_select_db($config["mysql_database"], $dblink), $lang["DBError"]);
print("<br />\n");

// do installation stuff
if (!$version = trim($wakkaConfig["wakka_version"])) $version = "0";
if (trim($wakkaConfig["wacko_version"])) $version = trim($wakkaConfig["wacko_version"]);
switch ($version)
{
// new installation
case "0":
	print("<strong>".$lang["Installing Stuff"]."</strong><br />\n");
	test(str_replace("%1","page",$lang["Creating table..."]),
		@mysql_query(
			"CREATE TABLE ".$config["table_prefix"]."pages (".
  			"id int(10) unsigned NOT NULL auto_increment,".
  			"tag varchar(250) NOT NULL default '',".
  			"supertag varchar(250) NOT NULL default '',".
  			"time datetime NOT NULL default '0000-00-00 00:00:00',".
  			"body text NOT NULL,".
  			"body_r text NOT NULL,".
  			"owner varchar(50) NOT NULL default '',".
  			"user varchar(50) NOT NULL default '',".
  			"latest enum('Y','N') NOT NULL default 'N',".
  			"handler varchar(30) NOT NULL default 'page',".
  			"comment_on varchar(250) NOT NULL default '',".
  			"PRIMARY KEY  (id),".
  			"FULLTEXT KEY tag (tag,body),".
  			"UNIQUE KEY idx_tag (tag),".
   			"KEY supertag (supertag),".
  			"KEY idx_supertag (supertag),".
  			"KEY idx_time (time),".
  			"KEY idx_latest (latest),".
  			"KEY idx_comment_on (comment_on) ".
			") TYPE=MyISAM;", $dblink), $lang["Already exists?"], 0);
	test(str_replace("%1","revision",$lang["Creating table..."]),
		@mysql_query(
			"CREATE TABLE ".$config["table_prefix"]."revisions (".
  			"id int(10) unsigned NOT NULL auto_increment,".
  			"tag varchar(250) NOT NULL default '',".
  			"supertag varchar(250) NOT NULL default '',".
  			"time datetime NOT NULL default '0000-00-00 00:00:00',".
  			"body text NOT NULL,".
  			"body_r text NOT NULL,".
  			"owner varchar(50) NOT NULL default '',".
  			"user varchar(50) NOT NULL default '',".
  			"latest enum('Y','N') NOT NULL default 'N',".
  			"handler varchar(30) NOT NULL default 'page',".
  			"comment_on varchar(50) NOT NULL default '',".
  			"PRIMARY KEY  (id),".
  			"KEY idx_tag (tag),".
  			"KEY idx_supertag (supertag),".
  			"KEY idx_time (time),".
  			"KEY idx_latest (latest),".
  			"KEY idx_comment_on (comment_on),".
   			"KEY supertag (supertag)".
			") TYPE=MyISAM;", $dblink), $lang["Already exists?"], 0);
	test(str_replace("%1","ACL",$lang["Creating table..."]),
		@mysql_query(
			"CREATE TABLE ".$config["table_prefix"]."acls (".
  			"page_tag varchar(250) NOT NULL default '',".
  			"supertag varchar(250) NOT NULL default '',".
			"privilege varchar(20) NOT NULL default '',".
  			"list text NOT NULL,".
 			"PRIMARY KEY  (page_tag,privilege),".
 			"KEY supertag (supertag)".
			") TYPE=MyISAM", $dblink), $lang["Already exists?"], 0);
	test(str_replace("%1","link tracking",$lang["Creating table..."]),
		@mysql_query(
			"CREATE TABLE ".$config["table_prefix"]."links (".
			"from_tag char(250) NOT NULL default '',".
  			"to_tag char(250) NOT NULL default '',".
  			"KEY from_tag (from_tag,to_tag),".
  			"KEY idx_from (from_tag),".
  			"KEY idx_to (to_tag)".
			") TYPE=MyISAM", $dblink), $lang["Already exists?"], 0);
	test(str_replace("%1","referrer",$lang["Creating table..."]),
		@mysql_query(
			"CREATE TABLE ".$config["table_prefix"]."referrers (".
  			"page_tag char(250) NOT NULL default '',".
  			"referrer char(150) NOT NULL default '',".
  			"time datetime NOT NULL default '0000-00-00 00:00:00',".
  			"KEY idx_page_tag (page_tag),".
  			"KEY idx_time (time)".
			") TYPE=MyISAM", $dblink), $lang["Already exists?"], 0);
	test(str_replace("%1","user",$lang["Creating table..."]),
		@mysql_query(
			"CREATE TABLE ".$config["table_prefix"]."users (".
  			"name varchar(80) NOT NULL default '',".
  			"password varchar(32) NOT NULL default '',".
  			"email varchar(50) NOT NULL default '',".
  			"motto text NOT NULL,".
  			"revisioncount int(10) unsigned NOT NULL default '20',".
  			"changescount int(10) unsigned NOT NULL default '50',".
  			"doubleclickedit enum('Y','N') NOT NULL default 'Y',".
  			"signuptime datetime NOT NULL default '0000-00-00 00:00:00',".
  			"show_comments enum('Y','N') NOT NULL default 'N',".
		        "bookmarks text NOT NULL,".
		        "lang varchar(20) NOT NULL default '',".
		        "show_spaces enum('Y','N') NOT NULL default 'Y',".
		        "showdatetime enum('Y','N') NOT NULL default 'Y',".
		        "typografica enum('Y','N') NOT NULL default 'Y',".
  			"PRIMARY KEY  (name),".
  			"KEY idx_name (name),".
  			"KEY idx_signuptime (signuptime)".
			") TYPE=MyISAM", $dblink), $lang["Already exists?"], 0);
	test(str_replace("%1","watches",$lang["Creating table..."]),
		@mysql_query("CREATE TABLE ".$config["table_prefix"]."pagewatches (".
		    "id int(10) NOT NULL auto_increment, ".
		    "user varchar(80) NOT NULL default '', ".
		    "tag varchar(250) NOT NULL default '', ".
		    "time timestamp(14) NOT NULL, ".
		    "PRIMARY KEY  (id)) TYPE=MyISAM", $dblink), $lang["Already exists?"], 0);

	test($lang["adding admin"], 
		@mysql_query("insert into ".$config["table_prefix"]."users set name = '".$config["admin_name"]."', password = md5('".mysql_escape_string($_POST["password"])."'), email = '".$config["admin_email"]."', signuptime = now()", $dblink), $lang["Hmm!"], 0);

	test($lang["Adding some pages..."], 1);
	require("setup/lang/inserts.".$config["language"].".php");
	break;

// The funny upgrading stuff. Make sure these are in order! //
// And yes, there are no break;s here. This is on purpose.  //

// from 0.1 to 0.1.1
case "0.1":
	print("<strong>0.1 ".$lang["to"]." 0.1.1</strong><br />\n");
	test($lang["pages alter"], 
		@mysql_query("alter table ".$config["table_prefix"]."pages add body_r text not null default '' after body", $dblink), $lang["Hmm!"], 0);

// from 0.1.1 to 0.1.2
case "0.1.1":
	print("<strong>0.1.1 ".$lang["to"]."o 0.1.2</strong><br />\n");
	test($lang["0.1.1"], 1);

// from Wakka 0.1.2 or Wacko R1
case "0.1.2":
	print("<strong>0.1.2 ".$lang["to"]." Wacko R2</strong><br />\n");
	test($lang["useralter"], 
		@mysql_query("alter table ".$config["table_prefix"]."users add bookmarks text not null default '', add lang varchar(20) NOT NULL default '', add show_spaces enum('Y','N') NOT NULL default 'Y'", $dblink), $lang["Hmm!"], 0);
	test(str_replace("%1","watches",$lang["Creating table..."]),
		@mysql_query("CREATE TABLE ".$config["table_prefix"]."pagewatches (id int(10) NOT NULL auto_increment, user varchar(80) NOT NULL default '', tag varchar(50) NOT NULL default '', time timestamp(14) NOT NULL, PRIMARY KEY  (id)) TYPE=MyISAM", $dblink), $lang["Already exists?"], 0);
	test($lang["Claiming all your base..."], 1);

// from Wacko R2
case "R2":
	print("<strong>Wacko R2 ".$lang["to"]." R3</strong><br />\n");
	test($lang["useralter"], 
		@mysql_query("alter table ".$config["table_prefix"]."users add showdatetime enum('Y','N') NOT NULL default 'Y', add typografica enum('Y','N') NOT NULL default 'Y'", $dblink), $lang["Hmm!"], 0);
	test(str_replace("%1","pages",$lang["And table..."]),
		@mysql_query("alter table ".$config["table_prefix"]."pages add supertag VARCHAR(250) NOT NULL default '' after tag, CHANGE tag tag VARCHAR(250) NOT NULL, ADD INDEX supertag (supertag)", $dblink), $lang["Hmm!"], 0);
	test(str_replace("%1","acls",$lang["And table..."]),
		@mysql_query("alter table ".$config["table_prefix"]."acls add supertag VARCHAR(250) NOT NULL default '', CHANGE page_tag page_tag VARCHAR(250) NOT NULL, ADD INDEX(supertag)", $dblink), $lang["Hmm!"], 0);
	test(str_replace("%1","links",$lang["And table..."]),
		@mysql_query("alter table ".$config["table_prefix"]."links CHANGE from_tag from_tag VARCHAR(250) NOT NULL, CHANGE to_tag to_tag VARCHAR(250) NOT NULL", $dblink), $lang["Hmm!"], 0);
	test(str_replace("%1","referrers",$lang["And table..."]),
		@mysql_query("alter table ".$config["table_prefix"]."referrers CHANGE page_tag page_tag VARCHAR(250) NOT NULL", $dblink), $lang["Hmm!"], 0);
	test(str_replace("%1","watches",$lang["And table..."]),
		@mysql_query("alter table ".$config["table_prefix"]."pagewatches CHANGE tag tag VARCHAR(250) NOT NULL", $dblink), $lang["Hmm!"], 0);
	test(str_replace("%1","revision",$lang["Creating table..."]),
		@mysql_query(
			"CREATE TABLE ".$config["table_prefix"]."revisions (".
  			"id int(10) unsigned NOT NULL auto_increment,".
  			"tag varchar(250) NOT NULL default '',".
  			"supertag varchar(250) NOT NULL default '',".
  			"time datetime NOT NULL default '0000-00-00 00:00:00',".
  			"body text NOT NULL,".
  			"body_r text NOT NULL,".
  			"owner varchar(50) NOT NULL default '',".
  			"user varchar(50) NOT NULL default '',".
  			"latest enum('Y','N') NOT NULL default 'N',".
  			"handler varchar(30) NOT NULL default 'page',".
  			"comment_on varchar(50) NOT NULL default '',".
  			"PRIMARY KEY  (id),".
  			"KEY idx_tag (tag),".
  			"KEY idx_supertag (supertag),".
  			"KEY idx_time (time),".
  			"KEY idx_latest (latest),".
  			"KEY idx_comment_on (comment_on),".
   			"KEY supertag (supertag)".
			") TYPE=MyISAM;", $dblink), $lang["Already exists?"], 0);
	test($lang["Moving data to revisions table..."],
		@mysql_query("INSERT INTO ".$config["table_prefix"]."revisions ( id, tag, supertag, time, body, body_r, owner, user, latest, handler, comment_on ) SELECT id, tag, supertag, time, body, body_r, owner, user, latest, handler, comment_on FROM ".$config["table_prefix"]."pages WHERE latest='N';", $dblink), $lang["VeryBad"], 0);
	test($lang["pages alter"], 
		@mysql_query("alter table ".$config["table_prefix"]."pages DROP INDEX idx_tag, ADD UNIQUE idx_tag (tag)", $dblink), $lang["Doubles"], 0);

	test($lang["Adding some pages..."], 1);
	require("setup/lang/inserts.".$config["language"].".php");

//R3 -> R4
//comment_on varchar(250)
      
}

?>

<p>
<?php echo $lang["NextStep"];?> <tt><?php echo $wakkaConfigLocation ?></tt>.
<?php echo $lang["MakeWrite"];?>.
<?php echo $lang["ForDetailsSee"];?>.
</p>

<form action="<?php echo myLocation(); ?>?installAction=writeconfig" method="POST">
<input type="hidden" name="config_s" value="<?php echo htmlspecialchars(serialize($config)) ?>" />
<input type="hidden" name="config[language]" value="<?php echo $config["language"]; ?>" />
<input type="submit" value="<?php echo $lang["Continue"];?>" />
</form>
