<div class="page">
<?php
if ($this->HasAccess("read"))
{
  if (!$this->page)
  {
    print(str_replace("%1",$this->href("edit","","",1),$this->GetResourceValue("DoesNotExists")));
  }
  else
  {
    // comment header?
    if ($this->page["comment_on"])
    {
      print("<div class=\"commentinfo\">This is a comment on ".$this->ComposeLinkToPage($this->page["comment_on"], "", "", 0).", posted by ".($this->IsWikiName($this->page["user"])?$this->Link($this->page["user"]):$this->page["user"])." at ".$this->page["time"]."</div>");
    }

    if ($this->page["latest"] == "N")
    {
      print("<div class=\"revisioninfo\">".
        str_replace("%1",$this->href(), 
          str_replace("%2",$this->GetPageTag(),
            str_replace("%3",$this->page["time"], 
              $this->GetResourceValue("Revision")))).".</div>");
    }


    // display page
    if ($this->page["body_r"]!="")
     $data = $this->Format($this->page["body_r"], "post_links");
    else
     $data = $this->Format($this->page["body"], "wakka");
    if ($this->tocAutoNumerate == 1) $data = $this->tocEnumerate($data,2); // TOC, Automatic numeration of headings
    print($data);

    // if this is an old revision, display some buttons
    if ($this->HasAccess("write") && ($this->page["latest"] == "N"))
    {
      $latest = $this->LoadPage($this->tag);
      ?>
      <br />
      <?php echo $this->FormOpen("edit") ?>
      <input type="hidden" name="previous" value="<?php echo $latest["time"] ?>" />
      <input type="hidden" name="body" value="<?php echo htmlspecialchars($this->page["body"]) ?>" />
      <input type="submit" value="<?php echo $this->GetResourceValue("ReEditOldRevision") ?>" />
      <?php echo $this->FormClose(); ?>
      <?php
    }
  }
}
else
{
  print($this->GetResourceValue("ReadAccessDenied"));
}
?>
</div>


<?php
if ($this->GetConfigValue("theme")!="tabs") {
if ($this->HasAccess("read") && $this->GetConfigValue("hide_comments") != 1)
{
	// load comments for this page
	$comments = $this->LoadComments($this->tag);
	
	// store comments display in session
	$tag = $this->GetPageTag();
	if (!isset($_SESSION["show_comments"][$tag]))
		$_SESSION["show_comments"][$tag] = ($this->UserWantsComments() ? "1" : "0");
		
	switch($_REQUEST["show_comments"])
	{
	case "0":
		$_SESSION["show_comments"][$tag] = 0;
		break;
	case "1":
		$_SESSION["show_comments"][$tag] = 1;
		break;
	}
	
	// display comments!
	if ($this->page && $_SESSION["show_comments"][$tag])
	{
		// display comments header
		?>
		<a name="comments"></a>
		<div class="commentsheader">
			<?php echo $this->GetResourceValue("Comments_all") ?> [<a href="<?php echo $this->href("", "", "show_comments=0")."\">".$this->GetResourceValue("HideComments"); ?></a>]
		</div>
		<?php
		
		// display comments themselves
		if ($comments)
		{

			foreach ($comments as $comment)
			{
				print("<a name=\"".$comment["tag"]."\"></a>\n");
				print("<div class=\"comment\">\n");
				$del = "";
        if ($this->IsAdmin() || $this->UserIsOwner($comment["tag"])) 
     			print("<a href=\"".$this->href("remove",$comment["tag"])."\"><img src=\"".$this->GetConfigValue("theme_url")."icons/1del.gif\" hspace=4 vspace=4 title=\"".$this->GetResourceValue("DeleteTip")."\" alt=\"".$this->GetResourceValue("DeleteText")."\"  align=\"right\" border=\"0\" /></a>");
        if ($comment["body_r"]) $strings = $comment["body_r"];
        else $strings = $this->Format($comment["body"], "wacko");
				print($this->Format($strings,"post_links")."\n");
        print("<div class=\"commentinfo\">\n-- ".($this->IsWikiName($comment["user"])?$this->Link("/".$comment["user"],"",$comment["user"]):$comment["user"])." (".$comment["time"].")\n</div>\n");
				print("</div>\n");
			}
		}
		
		// display comment form
		print("<div class=\"commentform\">\n");
		if ($this->HasAccess("comment"))
		{
			?>
				<?php echo $this->GetResourceValue("AttachComment"); ?><br />
				<?php echo $this->FormOpen("addcomment"); ?>
					<textarea name="body" rows="6" style="width: 100%"></textarea><br />
					<input type="submit" value="<?php echo $this->GetResourceValue("AttachCommentButton"); ?>" accesskey="s" />
				<?php echo $this->FormClose(); ?>
			<?php
		}
		print("</div>\n");
	}
	else
	{
		?>
		<div class="commentsheader">
		<?php
			switch (count($comments))
			{
			case 0:
				print($this->GetResourceValue("Comments_0"));				
				break;
			case 1:
				print($this->GetResourceValue("Comments_1"));
				break;
			default:
				print(str_replace("%1",count($comments), $this->GetResourceValue("Comments_n")));
			}
		?>
		
		[<a href="<?php echo $this->href("", "", "show_comments=1#comments")."\">".$this->GetResourceValue("ShowComments"); ?></a>]

		</div>
		<?php
	}
}
}
?>